/*
 * Jagg Directory Anaylzer
 *
 * Copyright (C) 2002-2003, Jordan Reed <reedjd@bitsmart.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package net.chaosserver.io;

import net.chaosserver.beans.AsynchronousPropertyChangeSupport;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import java.io.File;


public class FileMetaDataProgress {
    public static final String PROPERTY_LOADING_FILE =
        FileMetaDataProgress.class.getName() + "loadingFile";
    protected static FileMetaDataProgress self;
    protected PropertyChangeSupport propertyChangeSupport =
        new PropertyChangeSupport(this);

    protected FileMetaDataProgress() {
    }

    public static synchronized FileMetaDataProgress getInstance() {
        if (self == null) {
            self = new FileMetaDataProgress();
        }

        return self;
    }

    public void setProcessing(File processing) {
        // System.out.println(processing.getAbsolutePath());
        propertyChangeSupport.firePropertyChange(
            PROPERTY_LOADING_FILE, null, processing);
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }
}
