package net.chaosserver.jagg.swingui;

import net.chaosserver.io.FileMetaData;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import java.io.File;

import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class DirectoryTable extends JTable implements ListSelectionListener,
    PropertyChangeListener {
    public static final String FILE_META_DATA_PROPERTY =
        DirectoryTable.class.getName() + ".fileMetaData";
    public static final String PARENT_LOAD_STATE_PROPERTY =
        DirectoryTable.class.getName() + ".parentLoadState";
    DirectoryTableModel directoryTableModel;

    public DirectoryTable(File startDirectory) {
        directoryTableModel = new DirectoryTableModel(startDirectory);
        directoryTableModel.addPropertyChangeListener(this);

        setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        setModel(directoryTableModel);
    }

    public void valueChanged(ListSelectionEvent evt) {
        super.valueChanged(evt);

        if (!evt.getValueIsAdjusting() && (getSelectedRow() >= 0)) {
            // Select Made, so rebuild the table on it
            DirectoryTableModel directoryTableModel =
                (DirectoryTableModel) getModel();

            directoryTableModel.buildToChild(getSelectedRow());
        }
    }

    public void propertyChange(PropertyChangeEvent evt) {
        if (FILE_META_DATA_PROPERTY.equals(evt.getPropertyName())) {
            firePropertyChange(
                evt.getPropertyName(), evt.getOldValue(), evt.getNewValue());
        }

        if (
            FileMetaData.PARENT_META_DATA_LOADED_PROPERTY.equals(
                    evt.getPropertyName())) {
            String newState = (String) evt.getNewValue();
            firePropertyChange(
                evt.getPropertyName(), evt.getOldValue(), evt.getNewValue());
        }
    }
}
