/*
 * Jagg Directory Anaylzer
 *
 * Copyright (C) 2002-2003, Jordan Reed <reedjd@bitsmart.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package net.chaosserver.jagg.swingui;

import net.chaosserver.io.FileMetaData;
import net.chaosserver.io.FileMetaDataProgress;

import java.awt.BorderLayout;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import java.io.File;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JProgressBar;


public class StatusBar extends JPanel implements PropertyChangeListener {
    JProgressBar progressBar;
    JButton textProgressBar;
    DirectoryTable directoryTable;

    public StatusBar(DirectoryTable directoryTable) {
        setDirectoryTable(directoryTable);

        FileMetaDataProgress.getInstance().addPropertyChangeListener(this);

        setLayout(new BorderLayout());

        progressBar = new JProgressBar();
        progressBar.setIndeterminate(false);

        add(progressBar, BorderLayout.SOUTH);

        textProgressBar = new JButton();
        textProgressBar.setEnabled(false);

        add(textProgressBar, BorderLayout.NORTH);
    }

    public void setDirectoryTable(DirectoryTable directoryTable) {
        if (this.directoryTable != null) {
            this.directoryTable.removePropertyChangeListener(this);
        }

        this.directoryTable = directoryTable;

        if (this.directoryTable != null) {
            this.directoryTable.addPropertyChangeListener(this);
        }
    }

    public void propertyChange(PropertyChangeEvent evt) {
        if (
            FileMetaData.PARENT_META_DATA_LOADED_PROPERTY.equals(
                    evt.getPropertyName())) {
            String newState = (String) evt.getNewValue();

            if (
                FileMetaData.PARENT_METADATA_LOAD_STATE_LOADING.equals(
                        newState)) {
                progressBar.setIndeterminate(true);
            }

            if (FileMetaData.PARENT_METADATA_LOAD_STATE_LOADED.equals(newState)) {
                progressBar.setIndeterminate(false);
            }
        }

        if (
            FileMetaDataProgress.PROPERTY_LOADING_FILE.equals(
                    evt.getPropertyName())) {
            File loadingFile = (File) evt.getNewValue();

            if (loadingFile != null) {
                textProgressBar.setText(loadingFile.getAbsolutePath());
            }
        }
    }
}
