/*
 * Jagg Directory Anaylzer
 *
 * Copyright (C) 2002-2003, Jordan Reed <reedjd@bitsmart.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package net.chaosserver.jagg.swingui;

import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;


public class ToolBar extends JPanel implements ActionListener {
    public static final String ACTION_GPL =
        ToolBar.class.getName() + ".ACTION_GPL";

    public ToolBar() {
        setLayout(new FlowLayout(FlowLayout.LEFT));

        add(getGplButton());
    }

    public JButton getGplButton() {
        // Set the icon image
        URL gnuImageUrl =
            getClass().getResource("/net/chaosserver/jagg/swingui/gnu.gif");
        Toolkit toolkit = this.getToolkit();
        Image gnuImage = toolkit.createImage(gnuImageUrl);
        ImageIcon gnuImageIcon = new ImageIcon(gnuImage, "GPL");

        JButton gplButton = new JButton(gnuImageIcon);

        //gplButton.setContentAreaFilled(false);
        gplButton.setMargin(new Insets(0, 0, 0, 0));
        gplButton.setActionCommand(ACTION_GPL);
        gplButton.addActionListener(this);

        return gplButton;
    }

    public void actionPerformed(ActionEvent evt) {
        if (ACTION_GPL.equals(evt.getActionCommand())) {
            showLicensePanel();
        }
    }

    protected void showLicensePanel() {
        Frame parentFrame =
            (Frame) SwingUtilities.getAncestorOfClass(Frame.class, this);

        JDialog dialog =
            new JDialog(
                parentFrame, "GNU General Public License, version 2", true);

        dialog.setSize(parentFrame.getSize());
        dialog.setLocation(parentFrame.getLocation());

        dialog.getContentPane().add(new LicensePanel());
        dialog.show();
    }
}
